/** @file write.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.4
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef WRITE_CMDLINE_H
#define WRITE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef WRITE_CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define WRITE_CMDLINE_PARSER_PACKAGE "para_write"
#endif

#ifndef WRITE_CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define WRITE_CMDLINE_PARSER_PACKAGE_NAME "para_write"
#endif

#ifndef WRITE_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define WRITE_CMDLINE_PARSER_VERSION "0.4.4"
#endif

enum enum_sample_format { sample_format_arg_S8 = 0 , sample_format_arg_U8, sample_format_arg_S16_LE, sample_format_arg_S16_BE, sample_format_arg_U16_LE, sample_format_arg_U16_BE };

/** @brief Where the command line options are stored */
struct write_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *detailed_help_help; /**< @brief Print help, including all details and hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * loglevel_arg;	/**< @brief set loglevel (default='warning').  */
  char * loglevel_orig;	/**< @brief set loglevel original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel help description.  */
  char ** writer_arg;	/**< @brief select stream writer (default='alsa (file if alsa is unsupported)').  */
  char ** writer_orig;	/**< @brief select stream writer original value given at command line.  */
  unsigned int writer_min; /**< @brief select stream writer's minimum occurreces */
  unsigned int writer_max; /**< @brief select stream writer's maximum occurreces */
  const char *writer_help; /**< @brief select stream writer help description.  */
  int channels_arg;	/**< @brief specify number of channels (default='2').  */
  char * channels_orig;	/**< @brief specify number of channels original value given at command line.  */
  const char *channels_help; /**< @brief specify number of channels help description.  */
  int sample_rate_arg;	/**< @brief force given sample rate (default='44100').  */
  char * sample_rate_orig;	/**< @brief force given sample rate original value given at command line.  */
  const char *sample_rate_help; /**< @brief force given sample rate help description.  */
  enum enum_sample_format sample_format_arg;	/**< @brief specify sample format (default='S16_LE').  */
  char * sample_format_orig;	/**< @brief specify sample format original value given at command line.  */
  const char *sample_format_help; /**< @brief specify sample format help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int detailed_help_given ;	/**< @brief Whether detailed-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int writer_given ;	/**< @brief Whether writer was given.  */
  unsigned int channels_given ;	/**< @brief Whether channels was given.  */
  unsigned int sample_rate_given ;	/**< @brief Whether sample-rate was given.  */
  unsigned int sample_format_given ;	/**< @brief Whether sample-format was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct write_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure write_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure write_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *write_args_info_purpose;
/** @brief the usage string of the program */
extern const char *write_args_info_usage;
/** @brief all the lines making the help output */
extern const char *write_args_info_help[];
/** @brief all the lines making the detailed help output (including hidden options and details) */
extern const char *write_args_info_detailed_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser (int argc, char **argv,
  struct write_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use write_cmdline_parser_ext() instead
 */
int write_cmdline_parser2 (int argc, char **argv,
  struct write_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_ext (int argc, char **argv,
  struct write_args_info *args_info,
  struct write_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_dump(FILE *outfile,
  struct write_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_file_save(const char *filename,
  struct write_args_info *args_info);

/**
 * Print the help
 */
void write_cmdline_parser_print_help(void);
/**
 * Print the detailed help (including hidden options and details)
 */
void write_cmdline_parser_print_detailed_help(void);
/**
 * Print the version
 */
void write_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a write_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void write_cmdline_parser_params_init(struct write_cmdline_parser_params *params);

/**
 * Allocates dynamically a write_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized write_cmdline_parser_params structure
 */
struct write_cmdline_parser_params *write_cmdline_parser_params_create(void);

/**
 * Initializes the passed write_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void write_cmdline_parser_init (struct write_args_info *args_info);
/**
 * Deallocates the string fields of the write_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void write_cmdline_parser_free (struct write_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use write_cmdline_parser_config_file() instead
 */
int write_cmdline_parser_configfile (const char *filename,
  struct write_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_config_file (const char *filename,
  struct write_args_info *args_info,
  struct write_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int write_cmdline_parser_required (struct write_args_info *args_info,
  const char *prog_name);

extern const char *write_cmdline_parser_loglevel_values[];  /**< @brief Possible values for loglevel. */
extern const char *write_cmdline_parser_sample_format_values[];  /**< @brief Possible values for sample-format. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* WRITE_CMDLINE_H */
